package com.diagbot.facade.data;

import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.generator.config.rules.NamingStrategy;
import com.diagbot.dto.data.ColumnZhAndChDTO;
import com.diagbot.entity.StrBloodResult;
import com.diagbot.service.impl.StrBloodResultServiceImpl;
import com.diagbot.util.DateUtil;
import com.diagbot.util.EntityUtil;
import com.diagbot.util.MapUtil;
import com.diagbot.vo.data.AStrBloodResultVO;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;
import java.util.Map;

@Component
public class AStrBloodResultFacade extends StrBloodResultServiceImpl {
    @Autowired
    private ColumnFacade columnFacade;
    @Autowired
    private AMedAbnormalInfoFacade aMedAbnormalInfoFacade;

    public void getColumnZhAndCh(){
        List<ColumnZhAndChDTO> list=this.baseMapper.getColumnZhAndCh();
        list.forEach(s->{
            s.setEn(NamingStrategy.underlineToCamel(s.getEn()));
        });
        Map<String, String> columnMap= EntityUtil.makeMapWithKeyValue(list,"ch","en");
        Boolean flag=columnFacade.createColumn(columnMap,"strBloodResult");
        if(!flag){
            return;
        }
        //Map<String, String> map=columnFacade.getColumn("strBloodResult");
    }

    public void dealData(String columnMap,Map<String, Object> entityMap,Long hospitalId){
        StrBloodResult strBloodResult=new StrBloodResult();
        try {
            AStrBloodResultVO strBloodResultVO=(AStrBloodResultVO) MapUtil.mapToObject(entityMap, AStrBloodResultVO.class);
            BeanUtils.copyProperties(strBloodResultVO,strBloodResult);
            strBloodResult.setHospitalId(hospitalId);//医院编码
            strBloodResult.setAuditDate(DateUtil.parseDateTime(strBloodResultVO.getAuditDate()));//审核时间
            strBloodResult.setRecDate(DateUtil.parseDateTime(strBloodResultVO.getRecDate()));//记录时间
            strBloodResult.setRecordDate(DateUtil.parseDateTime(strBloodResultVO.getRecordDate()));//病历日期

            strBloodResult.setWholeData(columnMap);
            //判断数据库中是否存在，不存在insert
            if(isExist(strBloodResult)){
                strBloodResult.setGmtCreate(new Date());//记录创建时间
                this.save(strBloodResult);
            }else{
                strBloodResult.setGmtModified(new Date());//记录修改时间
                this.update(strBloodResult,new QueryWrapper<StrBloodResult>()
                        .eq("rec_id", strBloodResult.getRecId())
                        .eq("hospital_id", strBloodResult.getHospitalId())
                        .eq("behospital_code", strBloodResult.getBehospitalCode()));
            }

        }catch (Exception e){
            log.error(e.getMessage(),e);
            aMedAbnormalInfoFacade.saveAbnormalInfo("输血效果评价",strBloodResult.getRecId(), JSON.toJSONString(entityMap),"",e.getMessage());
        }

    }

    public Boolean isExist(StrBloodResult strBloodResult){
        Boolean flag=true;
        int count = this.baseMapper.selectCount(new QueryWrapper<StrBloodResult>()
                .eq("rec_id", strBloodResult.getRecId())
                .eq("hospital_id", strBloodResult.getHospitalId())
                .eq("behospital_code", strBloodResult.getBehospitalCode()));
        if(count>0){
            flag=false;
        }
        return flag;
    }
}
