package com.diagbot.facade.data;

import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.generator.config.rules.NamingStrategy;
import com.diagbot.dto.data.ColumnZhAndChDTO;
import com.diagbot.entity.StrBloodTransfusion;
import com.diagbot.service.impl.StrBloodTransfusionServiceImpl;
import com.diagbot.util.DateUtil;
import com.diagbot.util.EntityUtil;
import com.diagbot.util.MapUtil;
import com.diagbot.vo.data.AStrBloodTransfusionVO;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;
import java.util.Map;

@Component
public class AStrBloodTransfusionFacade extends StrBloodTransfusionServiceImpl {
    @Autowired
    private ColumnFacade columnFacade;

    @Autowired
    private AMedAbnormalInfoFacade aMedAbnormalInfoFacade;

    public void getColumnZhAndCh(){
        List<ColumnZhAndChDTO> list=this.baseMapper.getColumnZhAndCh();
        list.forEach(s->{
            s.setEn(NamingStrategy.underlineToCamel(s.getEn()));
        });

        Map<String, String> columnMap= EntityUtil.makeMapWithKeyValue(list,"ch","en");
        Boolean flag=columnFacade.createColumn(columnMap,"strBloodTransfusion");

        //Map<String, String> map=columnFacade.getColumn("strConsultationNote");
        if(!flag){
            return;
        }
    }

    public void dealData(String columnMap,Map<String, Object> entityMap,Long hospitalId){
        StrBloodTransfusion strBloodTransfusion=new StrBloodTransfusion();
        try {
            AStrBloodTransfusionVO strBloodTransfusionVO=(AStrBloodTransfusionVO) MapUtil.mapToObject(entityMap, AStrBloodTransfusionVO.class);
            BeanUtils.copyProperties(strBloodTransfusionVO,strBloodTransfusion);
            strBloodTransfusion.setHospitalId(hospitalId);//医院编码
            strBloodTransfusion.setStartTime(DateUtil.parseDateTime(strBloodTransfusionVO.getStartTime()));
            strBloodTransfusion.setEndTime(DateUtil.parseDateTime(strBloodTransfusionVO.getEndTime()));
            strBloodTransfusion.setAuditDate(DateUtil.parseDateTime(strBloodTransfusionVO.getAuditDate()));//审核时间
            strBloodTransfusion.setRecDate(DateUtil.parseDateTime(strBloodTransfusionVO.getRecDate()));//记录时间
            strBloodTransfusion.setRecordDate(DateUtil.parseDateTime(strBloodTransfusionVO.getRecordDate()));//病历日期

            strBloodTransfusion.setWholeData(columnMap);

            //判断数据库中是否存在，不存在insert
            if(isExist(strBloodTransfusion)){
                strBloodTransfusion.setGmtCreate(new Date());//记录创建时间
                this.save(strBloodTransfusion);
            }else{
                strBloodTransfusion.setGmtModified(new Date());//记录修改时间
                this.update(strBloodTransfusion,new QueryWrapper<StrBloodTransfusion>()
                        .eq("rec_id", strBloodTransfusion.getRecId())
                        .eq("hospital_id", strBloodTransfusion.getHospitalId())
                        .eq("behospital_code", strBloodTransfusion.getBehospitalCode()));
            }

        }catch (Exception e){
            log.error(e.getMessage(),e);
            aMedAbnormalInfoFacade.saveAbnormalInfo("输血记录", strBloodTransfusion.getRecId(),JSON.toJSONString(entityMap),"",e.getMessage());
        }

    }

    public Boolean isExist(StrBloodTransfusion strBloodTransfusion){
        Boolean flag=true;
        int count = this.baseMapper.selectCount(new QueryWrapper<StrBloodTransfusion>()
                .eq("rec_id", strBloodTransfusion.getRecId())
                .eq("hospital_id", strBloodTransfusion.getHospitalId())
                .eq("behospital_code", strBloodTransfusion.getBehospitalCode()));
        if(count>0){
            flag=false;
        }
        return flag;
    }
}
